------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Abstract_Item_Delegates;
limited with Qt4.Abstract_Item_Models;
limited with Qt4.Abstract_Item_Views;
limited with Qt4.Completers;
with Qt4.Icons;
limited with Qt4.Line_Edits;
with Qt4.Model_Indices;
with Qt4.Sizes;
with Qt4.String_Lists;
with Qt4.Strings;
limited with Qt4.Validators;
with Qt4.Variants;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Combo_Boxes is

   type Q_Combo_Box is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Combo_Box_Access is
     access all Q_Combo_Box'Class;
   for Q_Combo_Box_Access'Storage_Size use 0;

   type Q_Combo_Box_Pointer is tagged;

   procedure Add_Item
    (Self : not null access Q_Combo_Box'Class;
     Text : Qt4.Strings.Q_String;
     User_Data : Qt4.Variants.Q_Variant
       := Qt4.Variants.Create);

   procedure Add_Item
    (Self : not null access Q_Combo_Box'Class;
     Icon : Qt4.Icons.Q_Icon;
     Text : Qt4.Strings.Q_String;
     User_Data : Qt4.Variants.Q_Variant
       := Qt4.Variants.Create);

   procedure Add_Items
    (Self : not null access Q_Combo_Box'Class;
     Texts : Qt4.String_Lists.Q_String_List);

   function Completer
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Completers.Q_Completer'Class;

   function Count
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer;

   function Current_Index
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer;

   function Current_Text
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Strings.Q_String;

   function Duplicates_Enabled
    (Self : not null access constant Q_Combo_Box'Class)
       return Standard.Boolean;

   function Has_Frame
    (Self : not null access constant Q_Combo_Box'Class)
       return Standard.Boolean;

   not overriding
   procedure Hide_Popup
    (Self : not null access Q_Combo_Box)
       is abstract;

   function Icon_Size
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Sizes.Q_Size;

   procedure Insert_Item
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer;
     Text : Qt4.Strings.Q_String;
     User_Data : Qt4.Variants.Q_Variant
       := Qt4.Variants.Create);

   procedure Insert_Item
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer;
     Icon : Qt4.Icons.Q_Icon;
     Text : Qt4.Strings.Q_String;
     User_Data : Qt4.Variants.Q_Variant
       := Qt4.Variants.Create);

   function Is_Editable
    (Self : not null access constant Q_Combo_Box'Class)
       return Standard.Boolean;

   function Item_Delegate
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Abstract_Item_Delegates.Q_Abstract_Item_Delegate'Class;

   function Item_Icon
    (Self : not null access constant Q_Combo_Box'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Icons.Q_Icon;

   function Item_Text
    (Self : not null access constant Q_Combo_Box'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String;

   function Line_Edit
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Line_Edits.Q_Line_Edit'Class;

   function Max_Count
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer;

   function Max_Visible_Items
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer;

   function Minimum_Contents_Length
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer;

   function Model
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;

   function Model_Column
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer;

   procedure Remove_Item
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer);

   function Root_Model_Index
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Model_Indices.Q_Model_Index;

   procedure Set_Completer
    (Self : not null access Q_Combo_Box'Class;
     C : not null access Qt4.Completers.Q_Completer'Class);

   procedure Set_Duplicates_Enabled
    (Self : not null access Q_Combo_Box'Class;
     Enable : Standard.Boolean);

   procedure Set_Editable
    (Self : not null access Q_Combo_Box'Class;
     Editable : Standard.Boolean);

   procedure Set_Frame
    (Self : not null access Q_Combo_Box'Class;
     Enable : Standard.Boolean);

   procedure Set_Item_Delegate
    (Self : not null access Q_Combo_Box'Class;
     Delegate : not null access Qt4.Abstract_Item_Delegates.Q_Abstract_Item_Delegate'Class);

   procedure Set_Icon_Size
    (Self : not null access Q_Combo_Box'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Set_Item_Icon
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer;
     Icon : Qt4.Icons.Q_Icon);

   procedure Set_Item_Text
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer;
     Text : Qt4.Strings.Q_String);

   procedure Set_Line_Edit
    (Self : not null access Q_Combo_Box'Class;
     Edit : not null access Qt4.Line_Edits.Q_Line_Edit'Class);

   procedure Set_Max_Count
    (Self : not null access Q_Combo_Box'Class;
     Max : Qt4.Q_Integer);

   procedure Set_Max_Visible_Items
    (Self : not null access Q_Combo_Box'Class;
     Max_Items : Qt4.Q_Integer);

   procedure Set_Minimum_Contents_Length
    (Self : not null access Q_Combo_Box'Class;
     Characters : Qt4.Q_Integer);

   procedure Set_Model
    (Self : not null access Q_Combo_Box'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class);

   procedure Set_Model_Column
    (Self : not null access Q_Combo_Box'Class;
     Visible_Column : Qt4.Q_Integer);

   procedure Set_Root_Model_Index
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   procedure Set_Validator
    (Self : not null access Q_Combo_Box'Class;
     V : not null access constant Qt4.Validators.Q_Validator'Class);

   procedure Set_View
    (Self : not null access Q_Combo_Box'Class;
     Item_View : not null access Qt4.Abstract_Item_Views.Q_Abstract_Item_View'Class);

   not overriding
   procedure Show_Popup
    (Self : not null access Q_Combo_Box)
       is abstract;

   function Validator
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Validators.Q_Validator'Class;

   function View
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Abstract_Item_Views.Q_Abstract_Item_View'Class;

   procedure Clear
    (Self : not null access Q_Combo_Box'Class);

   procedure Clear_Edit_Text
    (Self : not null access Q_Combo_Box'Class);

   procedure Set_Current_Index
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer);

   procedure Set_Edit_Text
    (Self : not null access Q_Combo_Box'Class;
     Text : Qt4.Strings.Q_String);

   function Find_Text
    (Self  : not null access Qt4.Combo_Boxes.Q_Combo_Box'Class;
     Text  : Qt4.Strings.Q_String;
     Flags : Qt4.Match_Flags := +Match_Exactly+Match_Case_Sensitive)
       return Qt4.Q_Integer;

   package Q_Combo_Box_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Combo_Box, Q_Combo_Box_Access);

   type Q_Combo_Box_Pointer is
     new Q_Combo_Box_Pointers.Q_Pointer with null record;

end Qt4.Combo_Boxes;
